BEGIN {
# Simple awk script to generate queue lengths
# in a form suitable for plotting with xgraph/gnuplot.
# Modified by:
#   jvt.- Adapted to show both time-averaged queue length
#         and mean-observed (by the incoming packets) queue lenght
#   jvt.- Adapted to .nam trace format
#
# Juan M. Vozmediano. 2002.
#
	
	highest_packet_id = 0;
	TRANSIT=0.0;
	q = 0;
	t = 0.0;
	Q = 0;
	var = 0;
}
{
	fhist=sprintf("%s%s", OUTFILE,".avg");
	fq   =sprintf("%s%s", OUTFILE,".ins");
	fvar =sprintf("%s%s", OUTFILE,".var");
	
	action    = $1;
	time      = $3;
	src       = $5;
	dst       = $7;
	flow_id   = $13; 
	packet_id = $15;
	node_1_address = $19;
	node_2_address = $20; 
	
	
	if ((src == FROM_NODE)&&(dst == TO_NODE)) {
		if ((action == "+")||(action == "-")||(action == "d")){
			if (time > TRANSIT){
## print time-averaged queue length	
## -- last value is the average estimator  
## print variance of the queue length
				if (t<TRANSIT)
					t=TRANSIT;
				incr = time - t;
				if (incr){
					var += incr/(time-TRANSIT) * ((q-Q)*(q-Q)*(t-TRANSIT)/(time-TRANSIT) - var);
					printf("%f  %f\n", time, var)  > fvar;
					
					Q = (Q*(t-TRANSIT) + q*incr)/(time-TRANSIT);
					printf("%f  %f\n", time, Q)  > fhist;

				}	
				printf("%f  %f  \n", time, q) > fq;
			}
## print instantaneous queue length	  
			if (action == "+")
				q++;
			else
				q--;
##Save t
			t = time;
			
		}
	}
}


