BEGIN {
#
# Simple awk script to compute mean and variance
# of a value list
# Input file: lines with pairs <time, value>
#
  TRANSIT=0
  n = 0;
  m = 0;
  variance = 0;	
  maximum = 0;
  minimum =0;
}
{
  if ($1 >= TRANSIT){
	x = $2;
	oldnum = n;
	n = n + 1.0;
	tmp = x - m;
	m = m + (tmp / n);

	if ( 1 == n ){
	  maximum = x;
	  minimum = x;
	  variance = 0;
	}
	else{
	  if (x > maximum)
		maximum = x;
	  else if (x < minimum)
		minimum = x;
	  variance = (oldnum-1)/oldnum * variance + tmp*tmp / n;
	}
  }
}
END{
  printf("n = %e", n);
  if (n > 0) {
	printf(" [%e ..", minimum);
	printf("%e] ", maximum);
	printf("m = %e", m);
  }
  if (n > 2){
	printf("  var = %e", variance);
  }  
  printf("\n");
}


