BEGIN {
# simple awk script to generate end-to-end packet lifetime statistics
# in a form suitable for plotting with xgraph.
# Modified jvt.- Adapted to .nam trace format
# Lloyd Wood, July 1999.
# http://www.ee.surrey.ac.uk/Personal/L.Wood/ns/
  
  TRANSIT=0;
  highest_packet_id = 0;
  FID=-1;
  OUTFILE="deleteme"
}
{
  action = $1;
  time = $3 * 1;
  src = $5;
  dst = $7;
  flow_id = 1 * $13; 
  packet_id = 1 * $15;
  aux = $19;
  sub("{","",aux);
  node_1_address = sprintf("%d",aux);
  node_2_address = sprintf("%d",$20);
  
#  
  if ( $10 == "-e" ) {
    if ((FID == -1) || (flow_id == FID)) {
      if ( packet_id > highest_packet_id ) highest_packet_id = 1 * packet_id;
      
# getting start time is not a problem, provided you're not starting
# traffic at 0.0.
# could test for sending node_1_address or flow_id here.
      if (action == "+") {
		if ( start_time[packet_id] == 0 )  start_time[packet_id] = time;
      }
# only useful for small unicast where packet_id doesn't wrap.
# checking receive means avoiding recording drops
      if ( action != "d" ) {
        if ( action == "r" ) {
# could test for receiving node_2_address or flow_id here.
          if (node_2_address == dst) {
            end_time[packet_id] = time;
          }
        }
      } else {
        end_time[packet_id] = -1;
      }
    }
  }
}                                                         
END {
  favg   =sprintf("%s%s", OUTFILE,".avg");
  fvar   =sprintf("%s%s", OUTFILE,".var");
  
  mean   = 0.0;
  var    = 0.0;
  num    = 0.0;
  
  for ( packet_id = 0; packet_id <= highest_packet_id; packet_id++ ) {
    start = start_time[packet_id];
    end   = end_time[packet_id];
    if (end >= TRANSIT){
      if ( start < end ) {
        packet_duration = end - start;
        x = packet_duration;
        num = num +1; 
        printf("%f %f\n", end, packet_duration) > OUTFILE;
        
        if (num>1){   
#mean here accounts from 0 to num  -1
          var += (x-mean)*(x-mean)/num - var/(num-1);
        }
        
        mean   += (x - mean)/num;
        printf("%f %f\n", end, mean) > favg;
        
        
        printf("% 10.6f % 10.6f\n", end, var) > fvar;
        
      }
    }
  }
}


