function abs(val)
{
  if (val > 0){
	return val;
  }
  else {
	return -val;
  }
}

function gammln(xx)
{
##	  double x,y,tmp,ser;
##	  int j;
  y=x=xx;
  tmp=x+5.5;
  tmp -= (x+0.5)*log(tmp);
  ser=1.000000000190015;
  for (j=0;j<=5;j++){
	ser += cof[j]/++y;
  }
  return -tmp+log(2.5066282746310005*ser/x);
}

function alfa(a, b, x)
	 
#   Returns the incomplete beta function Ix(a; b).
{

#	  float bt;
  if (x < 0.0 || x > 1.0) {
	printf("Bad x in routine alfa");
  }
  if (x == 0.0 || x == 1.0) {
	bt=0.0;
  }
  else {
# Factors in front of the continued fraction.
	bt=exp(gammln(a+b)-gammln(a)-gammln(b)+a*log(x)+b*log(1.0-x));
  }
  if (x < (a+1.0)/(a+b+2.0)){
	
# Use continued fraction directly.
	return bt*betacf(a,b,x)/a;
  }
  else {
	
# Use continued fraction after making the symmetry transformation. 
	return 1.0-bt*betacf(b,a,1.0-x)/b;
  }
}

function betacf(a, b, x)
# Used by alfa: Evaluates continued fraction for incomplete beta function 
# by modfied Lentz's method (x5.2).
{
#  int m,m2;
#  float aa,c,d,del,h,qab,qam,qap;

  qab=a+b; 

#  These q's will be used in factors that occur           
# in the coficients (6.4.6). 

  qap=a+1.0;
  qam=a-1.0;
  c=1.0;  

#  First step of Lentz's method.

  d=1.0-qab*x/qap;
  if (abs(d) < FPMIN){
	d=FPMIN;
  }
  d=1.0/d;
  h=d;
  for (m=1;m<=MAXIT;m++) {
	m2=2*m;
	aa=m*(b-m)*x/((qam+m2)*(a+m2));
	d=1.0+aa*d; 
	
# One step (the even one) of the recurrence.

	if (abs(d) < FPMIN){
	  d=FPMIN;
	}
	c=1.0+aa/c;
	if (abs(c) < FPMIN){
	  c=FPMIN;
	}
	d=1.0/d;
	h *= d*c;
	aa = -(a+m)*(qab+m)*x/((a+m2)*(qap+m2));
	d=1.0+aa*d; 
# Next step of the recurrence (the odd one).
	if (abs(d) < FPMIN){
	  d=FPMIN;
	}
	c=1.0+aa/c;
	if (abs(c) < FPMIN) {
	  c=FPMIN;
	}
	d=1.0/d;
	del=d*c;
	h *= del;
	if (abs(del-1.0) < EPS) {
	  break; 
# Are we done?
	}
  }
  if (m > MAXIT) {
	printf("a or b too big, or MAXIT too small in betacf");
  }
  return h;
}


function invstudent (n, alf) {
# v: grados de libertad
  v = n - 1;
  a = v/2;
  b = 0.5;
  
  alfabuscada = alf;
  t = 0;
  do {
	t = t + step;
	x = v / ( v + t * t );
  } while ( alfabuscada <  alfa(a, b, x));
	
  return t;
}


BEGIN{
  MAXIT = 100;
  EPS = 3.0e-7;
  FPMIN = 1.0e-30;
  cof[0]=76.18009172947146;
  cof[1]=-86.50532032941677;
  cof[2]= 24.01409824083091;
  cof[3]=-1.231739572450155;
  cof[4]= 0.1208650973866179e-2;
  cof[5]=-0.5395239384953e-5;
  step = 0.0001;

  getline ;

  if ($1=="--help"){
	printf ("num alfa : Devuelve t(n-1,alfa/2)\n");
	printf ("num alfa \"--intervalo\" media varianza: Devuelve el intervalo de confianza\n");
  }
  else {
	t = invstudent($1, $2);
	if ($3=="--intervalo"){
	  m = $4;
	  s = $5;
	  width = sqrt(s/$1)*t;
	  printf ("%g < mu < %g  anchura = %g\n", m - width, m + width, 2*width);
	}
	else {
	  printf("DISTR.T.INV(n-1=%f, alfa=%f) = %f\n" ,  $1 -1, $2, t);
	}
  }
}
