#Inicio de link.tcl
# ns link.tcl SEED RBIN SIMTIME
puts "ns link.tcl SEED RBIN SIMTIME"
puts "ns link.tcl $argv"
#Set seed
ns-random [lindex $argv 0]

# Create a new simulator object.
set ns [new Simulator]

# Create a nam trace datafile.
set namfile      [open "[lindex $argv 0].nam" w]
$ns namtrace-all       $namfile
$ns set-animation-rate  0.8ms

# Create nodes.
set node(1) [$ns node]
set node(2) [$ns node]

# Create links between nodes.
# Light speed Km/s
set c    0.67
set c0   270000
#Distance Km
set d    5000
set rbin [lindex $argv 1]
set retr [ expr $d / ( $c0 * $c ) ]
set q    20

$ns duplex-link $node(1) $node(2) $rbin $retr DropTail
# Set Queue Properties for link 1<->2
[[$ns link $node(1) $node(2)] queue] set limit_ $q
#Monitor the queue for the link
$ns duplex-link-op $node(1) $node(2) queuePos 0.5

# Create agents, with given maximum packet size 
# and flow indicator
set agent(1) [new Agent/UDP]
$ns attach-agent $node(1) $agent(1)
$agent(1) set fid_ 1
$agent(1) set packetSize_ 99999

# Create traffic sources and add them to the agent.
set traffic_source(1) [new Application/Traffic/Exponential]
$traffic_source(1) attach-agent $agent(1)
$traffic_source(1) set burst_time_ 0ms
$traffic_source(1) set idle_time_  0.5
$traffic_source(1) set rate_       999999999.9k
$traffic_source(1) set packetSize_ 2000

set agent(2) [new Agent/Null]
$ns attach-agent $node(2) $agent(2)

# Connect agents.
$ns connect $agent(1) $agent(2)

# Run the simulation
proc finish {} {
  global ns namfile
  $ns flush-trace
  close $namfile
  exit 0
}

$ns at 0.0 "$traffic_source(1) start"
$ns at [lindex $argv 2] "finish"
$ns run
#Fin de link.tcl
