//Inicio de net1.cc
#include <stdio.h>
#include <stdlib.h>
//*******************************************************
// Includes for distributions, statistics and 
// event simulation
#include "netelem.h"

//**************************************************
//Main program
int  main (int argc, char* argv[])
{
  
  if (7 != argc){
    printf(\
		   "Usage: %s <seed> <arrival> <psize> <capacity> <q> <time>\n",\
           argv[0]);
    printf("<arrival>  rate in packets per timeunit\n");
    printf("<psize>    in bits per packet\n");
    printf("<capacity> server capacity in bits per timeunit\n");
    printf("<q>        input queue, in bits. -1 if unlimited\n");
    return -1;
  }
  for (int k=0; k<argc; k++)
    printf("%s ",argv[k]);
  printf("\n");

  EvSim::AssertVersion(1.20);
  Distrib::InitRng(atoi(argv[1]));

  timeunits tarriv   = (timeunits) (1/atof(argv[2]));
  timeunits psiz     = (timeunits) atof(argv[3]);
  
  PacketSource S1(new Exponential(tarriv), new Exponential(psiz));

  Server       C1("C1", (int) atof(argv[4]), (int) atoi(argv[5]));
  PacketSink   K1;

  S1.ConnectTo(&C1);
  C1.ConnectTo(&K1);

  S1.Start(0);

  Simulation.Run(0, (timeunits)atof(argv[6]));
}
//Fin de net1.cc
